<template>
  <v-row>
    <!-- firstname field -->
    <v-col cols="12" md="6">
      <v-text-field
        v-model="obj.firstname"
        @input="$emit('update:firstname', obj.firstname)"
        :rules="firstRules"
        label="ชื่อ"
        required
        filled
      ></v-text-field>
    </v-col>
    <!-- lastname field -->
    <v-col cols="12" md="6">
      <v-text-field
        v-model="obj.lastname"
        @input="$emit('update:lastname', obj.lastname)"
        :rules="lastRules"
        label="นามสกุล"
        required
        filled
      ></v-text-field>
    </v-col>
    <!-- select type -->
    <v-col cols="12" md="12">
      <v-select
        :items="items"
        filled
        v-model="obj.type"
        @input="$emit('update:type', obj.type)"
        item-text="typeName"
        item-value="typeId"
        label="ประเภทผู้ร่วมลงทุน"
        :rules="typeRules"
        dense
      ></v-select>
    </v-col>
    <!-- idcard field -->
    <v-col cols="12" md="12" v-show="obj.type == 'PE'">
      <v-text-field
        v-model="obj.id_card"
        label="เลขบัตรประชาชน"
        @input="$emit('update:id_card', obj.id_card)"
        :rules="id_cardRules"
        filled
        @blur="checkIdCard()"
        required
        v-if="obj.type == 'PE'"
      ></v-text-field>
      <v-alert dense outlined type="error" v-if="idCard !== ''">
        {{ idCard }}
      </v-alert>
    </v-col>
    <!-- idcardniti field -->
    <v-col cols="12" md="12" v-show="obj.type == 'CO'">
      <v-text-field
        v-model="obj.id_cardNiti"
        @input="$emit('update:id_cardNiti', obj.id_cardNiti)"
        label="เลขนิติบุคคล"
        :rules="id_cardNitiRules"
        @blur="checkIdCardNiti()"
        filled
        required
        v-if="obj.type == 'CO'"
      ></v-text-field>
      <v-alert dense outlined type="error" v-if="idCardNiti !== ''">
        {{ idCardNiti }}
      </v-alert>
    </v-col>
    <!-- email field -->
    <v-col cols="12" md="6">
      <v-text-field
        v-model="obj.email"
        :rules="emailRules"
        @input="$emit('update:email', obj.email)"
        label="E-mail"
        filled
        @blur="checkEmail()"
        required
      ></v-text-field>
      <v-alert dense outlined type="error" v-if="dupEmail !== ''">
        {{ dupEmail }}
      </v-alert>
    </v-col>
    <!-- telno field -->
    <v-col cols="12" md="6">
      <v-text-field
        v-model="obj.telNo"
        :rules="telRules"
        @input="$emit('update:telNo', obj.telNo)"
        label="เบอร์โทรที่สามารถติดต่อได้"
        filled
        required
      ></v-text-field>
    </v-col>
    <!-- password field -->
    <v-col cols="12" md="6">
      <v-text-field
        v-model="obj.password"
        :rules="passRules"
        @input="$emit('update:password', obj.password)"
        label="Password"
        type="password"
        filled
        required
      ></v-text-field>
    </v-col>
    <!-- confirm password field -->
    <v-col cols="12" md="6">
      <v-text-field
        v-model="obj.cPassword"
        :rules="cPassRules"
        @input="$emit('update:cPassword', obj.cPassword)"
        label="Confirm Password"
        type="password"
        required
        filled
      ></v-text-field>
    </v-col>
    <!-- address field -->
    <v-col cols="12" md="12">
      <v-textarea
        filled
        label="ที่อยู่"
        @input="$emit('update:address', obj.address)"
        :rules="addressRules"
        auto-grow
        v-model="obj.address"
      ></v-textarea>
    </v-col>
  </v-row>
</template>

<script>
export default {
  data() {
    return {
      obj: {},
      dupEmail: "",
      idCard: "",
      idCardNiti: "",
      items: [
        { typeName: "บุคคล", typeId: "PE" },
        { typeName: "นิติบุคคล", typeId: "CO" },
      ],
      addressRules: [(v) => !!v || "กรุณากรอก ที่อยู่"],
      firstRules: [(v) => !!v || "กรุณากรอก ชื่อ"],
      lastRules: [(v) => !!v || "กรุณากรอก นามสกุล"],
      cPassRules: [
        (v) => !!v || "กรุณากรอก การยืนยันรหัสผ่าน",
        (v) => v === this.obj.password || "รหัสผ่านไม่ตรงกัน",
      ],
      passRules: [
        (v) => !!v || "กรุณากรอก รหัสผ่าน",
        (v) =>
          (!!v && v.length >= 6) || "Password ต้องไม่น้อยกว่า 6 ตัวเท่านั้น",
        (v) =>
          (!!v && v.length <= 18) || "Password ต้องไม่มากกว่า 18 ตัวเท่านั้น",
      ],
      typeRules: [(v) => !!v || "กรุณาเลือก ประเภทผู้ร่วมลงทุน"],
      emailRules: [
        (v) => !!v || "กรุณากรอก อีเมล์",
        (v) => /.+@.+/.test(v) || "อีเมล์ ไม่ตามฟอร์แมต",
      ],
      telRules: [
        (v) => !!v || "กรุณากรอก เบอร์โทร",
        (v) =>
          /^\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$/.test(v) ||
          "เบอร์โทร ไม่ตามฟอร์แมต",
      ],
      id_cardRules: [(v) => !!v || "กรุณากรอก เลขบัตรประชาชน"],
      id_cardNitiRules: [
        (v) => !!v || "กรุณากรอก นิติบุคคล",
      ],
    };
  },
  methods: {
    async checkEmail() {
      if (this.obj.email != "") {
        await this.$store.dispatch("auth/validDupEmail", this.obj.email);
        let dupEmail = await this.$store.getters["auth/result"];
        if (dupEmail === true) {
          this.dupEmail = "อีเมล์ซํ้า";
        } else {
          this.dupEmail = "";
        }
      }
    },
    checkIdCardNiti() {
      this.idCardNiti = "";
      let validCard = this.checkDigitIdCard(this.obj.id_cardNiti);
      if (validCard == false) {
        this.idCardNiti = "เลขนิติบุคคล ไม่ตามฟอร์แมต";
      } else {
        this.idCardNiti = "";
      }
    },
    checkIdCard() {
      this.idCard = "";
      let validCard = this.checkDigitIdCard(this.obj.id_card);
      if (validCard == false) {
        this.idCard = "เลขบัตรประชาชน ไม่ตามฟอร์แมต";
      } else {
        this.idCard = "";
      }
    },
    checkDigitIdCard(cardId) {
      var multi_num = 13;
      var str_digit = 0;
      var result = 0;
      while (multi_num != 1) {
        result = result + cardId.charAt(str_digit) * multi_num;
        multi_num = multi_num - 1;
        str_digit = str_digit + 1;
      }

      result = result % 11;
      if (result == 0) result = 10;

      result = 11 - result;

      if (result == 10) result = 0;

      if (result == cardId.charAt(12)) {
        return true;
      } else {
        return false;
      }
    },
  },
};
</script>

<style>
</style>